{-# LANGUAGE ExplicitNamespaces, TypeOperators #-}
module GEODE.Metadata.Record
  ( Record(..) ) where

import GEODE.Metadata.Types (type (@)(..))
import System.FilePath ((</>))
import Text.Printf (printf)

class Record a where
  uid :: a -> String
  relativePath :: a -> String -> FilePath

instance (Record a, Record b) => Record (a @ b) where
  uid (a :@: b) = printf "%s_%s" (uid a) (uid b)
  relativePath (a :@: b) extension =
    relativePath a "" </> relativePath b extension
