{-# LANGUAGE OverloadedStrings #-}
module GEODE.Metadata.Work
  ( Work(..) ) where

import Data.Aeson (ToJSON(..))
import Data.Csv (FromField(..), ToField(..))
import Data.Char (toLower)
import Data.ByteString.Char8 as ByteString (map)

data Work = EDdA | LGE | Wikipedia deriving (Eq, Ord, Read, Show)

instance FromField Work where
  parseField = recognize . ByteString.map toLower
    where
      recognize "EDdA" = pure EDdA
      recognize "LGE" = pure LGE
      recognize "Wikipedia" = pure Wikipedia
      recognize _ = mempty

instance ToField Work where
  toField = toField . show

instance ToJSON Work where
  toJSON = toJSON . show

